package RXParser;

sub new {
	my($class, $self)=(shift, {@_});
	+bless $self, $class
}

sub save {
	my($self, $file)=(shift, shift);
	use Data::Dumper;($Data::Dumper::Terse, $Data::Dumper::Indent)=1;
	use fileops;
	&fileops::oswritefile($file, 'use '.ref($self).';+ ', Dumper $self);
	+$self
}

sub load {+do $_[1]}

sub error {
	my$self=shift;
	print STDERR "\n", (caller)[0], ': ', @_, ' at ',
				(caller)[1], ' line ', (caller)[1, 2], "\n" unless $self->{silent};
	exit;
}

##################################################################################
sub filter {
	my$self=shift;
	use RXParser::Filter;
	+RXParser::Filter
}

sub DESTROY{}

sub AUTOLOAD {
	my($self, $package, @args)=(shift, 'RXParser', @_);
	return undef unless ${+$package.'::AUTOLOAD'}=~/([^:]+)$/o;
	my$osub=lc $1;
	my($dh, $cd);
	opendir $dh, $package;readdir $dh;readdir $dh;
	while($cd=readdir $dh) {
		next unless $cd=~/^(.+?)\.pm$/io && lc $1 eq $osub;
		my$nsub=$1;
		eval <<".";
		sub $package\::$osub {
			my\$self=shift;
			use $package\::$nsub;
			+$package\::$nsub->new(\@_)
		}
.
		return $package->$osub(@args);
	}
	closedir $dh;
	eval qq(sub $package\::$osub {+undef});
	+undef
}

+1;

__END__
=head1 NAME

 RXParser 2.0 - Universal document translator

=head1 AUTHOR

 Shatrow Alexey <cdch@yandex.ru>,
 Krasnodar, March 13, 2005 (c)
=cut
