package RXParser::Filter;
use Entities qw'decode_entities';

BEGIN {
	%MODE=(
		'HTML'=>sub{+&decode_entities(shift)},
		'TEXT'=>sub{+&decode_entities($MODE{'TEXT/ENTITY'}(shift))},
		'TEXT/ENTITY'=>sub{
			my$str=shift;
			$str=~s/<[^>]+>//gos;
			+$str
		},
		'DATE'=>sub{
			my$date=shift;
			return $date unless $date=~/(\d{1,2})\D+(\d{1,2})\D+(\d{4}|\d{2})/o;
			+sprintf '%02d.%02d.%04d', $1, $2, $3<40?$3+2000:$3
		},
		'LINK'=>sub{+$MODE{'TEXT/ENTITY'}(shift)}
	);
}

sub prepare {
	my($self, $str, $mode)=(shift, shift, uc shift);
	+ ref $MODE{$mode} eq 'CODE' ? $MODE{$mode}($str) : $str
}

sub args {
	my($self, $args, $ARGS, %result, $arg, $carg)=(shift, shift, shift);
	foreach$arg(keys %$ARGS) {
		next if defined $result{$arg};
		foreach$carg(@{$$ARGS{$arg}}) {
			$result{$arg}=$args->{$carg};
			last if defined $result{$arg};
		}
	}
	+\%result
}

sub trim {+$_[1]=~/^\s*(.*?)\s*$/os? $1 : $_[1]}

+1;