package RXParser::Rules;
use base 'RXParser';

sub prepare {
	my$self=shift;
	my($vi, $vp)=(1, 'v%d');
	my$filename=shift || $self->{file} || $self->error('Input rules filename not found');

	use fileops;

	my$fh=&fileops::osopen($filename);
	$self->{result}={};

		while(<$fh>) {
			next unless index $_, '#';
			if(/^\s*(['"]?)(.+?)\1\s*(?:\:\s*(.+?))?\s*\((.+?)\)\s*(.)[\r\n]*$/os) {
				my($title, $name, $args, $dot, $i, %args)=($2, $3, $4, qr(^\Q$5\E\s*$)o, 0);
				$name||=sprintf $vp, $vi;
				while($args=~/\s*(["']?)([^\1,\:]+)\1\s*(?:\:\s*(["']?)([^,]+)\3)?\s*,?/goc) {
					my$key=$self->filter->trim($2);
					$args{$key}={
						order=>++$i,
						type=>$4
					} unless $key eq undef
				}
				$self->{result}{$name}={
					order=>$vi++,
					title=>$title,
					args=>{%args}
				};
				while(<$fh>) {
					last if /$dot/o;
					s/^\s*(.*?)\s*$/\\s\*$1\\s\*/o;
					$self->{result}{$name}{rx}.=$_;
				}
				$self->{result}{$name}{rx}=~s/(?:\\s\*){2,}/\\s*/go;
				$self->{result}{$name}{rx}=~s/^(?:\\s\*)(.*?)(?:\\s\*)$/$1/go;
				$self->{result}{$name}{rx}=qr($self->{result}{$name}{rx})si;
			}
		}
	&fileops::osclose($fh);
	+$self
}

+1;