package RXParser::Wizard;
use base 'RXParser';

sub _rules_ {
	my$self=shift;
	return $self->{rules} if defined $self->{rules};
	+$self->{rules}=$self->rules(file=>$self->{rls})
}

sub _template_ {
	my$self=shift;
	return $self->{template} if defined $self->{template};
	+$self->{template}=$self->template(file=>$self->{tpl})
}

sub prepare {
	my$self=shift;
	my$args=$self->filter->args({@_}, {
		tpl=>[qw'template rxml t'],
		rls=>[qw'mapping rules rx r'],
		in=>[qw'input filein i'],
		out=>[qw'output fileout o']
	});

	defined $self->{$_} or $self->{$_}=delete $args->{$_} foreach qw'in out rls tpl';
	ref $self->{$_} eq 'ARRAY' or $self->{$_}=[$self->{$_}] foreach qw'in';

	$self->_rules_->prepare or return undef;
	$self->_template_->prepare or return undef;

	+$self
}

sub saveAs {
	my$self=shift;
	$self->_rules_->prepare and $self->_template_->prepare or return undef;

	for(my$i=0; $i<@{$self->{in}}; $i++) {
		$self->{template}{output}=$self->{out};
			#     : "fi*le" # * -> 0..$i
		$self->{template}{output}=~s/\*/$i/go;
		$self->{template}{parser}=$self->parser(
						rules=>$self->{rules},
						file=>$self->{in}[$i]
		)->prepare;
		$self->error('Error transforming "', $self->{in}[$i], '" to "',
											$self->{template}{output}, '"')
		unless $self->{template}->saveAs;
	}

	+$self
}

+1;